<?php

require_once('classes/render-adminlte.class.php');
require_once('classes/pageinclude.class.php');

require_once('inc_functions.php');

// ----------------------------------------------------------------------
// CONFIG
// ----------------------------------------------------------------------

$aReplace=include("./config/page_replacements.php");
// $aReplace['{{DIR_ADMINLTE}}']='/vendor/admin-lte/AdminLTE-3.2.0/';


// ----------------------------------------------------------------------
// OUTPUT
// ----------------------------------------------------------------------

$renderAdminLTE=new renderadminlte();
$oContent=new pageinclude();


// ---------- PAGE STYLE
// $aReplace['{{PAGE_SKIN}}']='';
// $aReplace['{{PAGE_LAYOUT}}']='layout-navbar-fixed layout-fixed sidebar-mini';


// ---------- TOP BAR
// see https://adminlte.io/docs/3.2/components/main-header.html
$aTopnav=include("./config/navi_top.php");
$aReplace['{{NAVI_TOP}}']=''
    . $renderAdminLTE->addWrapper(
        'nav', ['class'=>'main-header navbar navbar-expand navbar-white navbar-light'],
        $renderAdminLTE->getTopNavigation($aTopnav)
        // . 'hello'
        // add 2nd navbar if needed
    )
    ;


// ---------- LEFT BAR
$aSidebarNav=include("./config/navi_left.php");

$aSidebarNav[1]['children'][]=[
    'href'=>'/component?',
    'label'=>'Overview', 
    'icon'=>'fa-solid fa-th-large'
];
foreach($renderAdminLTE->getComponents(1) as $sId=>$aComponent){
    $aSidebarNav[1]['children'][]=[
        'href'=>'/component?id='.$sId,
        'label'=>$aComponent['label'], 
        'icon'=>'fa-solid fa-square-full'
    ];
}

$aReplace['{{NAVI_LEFT}}']=''
    . $renderAdminLTE->addWrapper(
        'nav', ['class'=>'mt-2'],
        $renderAdminLTE->getSidebarNavigation($aSidebarNav)
    );


// ---------- PAGE BODY
$aReplace['{{PAGE_HEADER_LEFT}}']='<h1>Titel :: {{PAGE_HEADER_LEFT}}</h1>';
$aReplace['{{PAGE_HEADER_RIGHT}}']='{{PAGE_HEADER_RIGHT}}';
// $aReplace['{{PAGE_FOOTER_RIGHT}}']='{{TODO: PAGE_FOOTER_RIGHT}}';
// $aReplace['{{PAGE_FOOTER_LEFT}}']='{{TODO: PAGE_FOOTER_LEFT}}';



$sBody='';


// ----- get params
global $aParams;
$aParams = array();

$sPagesDir='./pages';
if (count($_GET))
foreach ($_GET as $key => $value)
    $aParams[$key] = $value;
if (count($_POST))
foreach ($_POST as $key => $value)
    $aParams[$key] = $value;

foreach (array_keys($aParams) as $sKey) {
$aParams[$sKey] = is_string($aParams[$sKey])
    ? str_replace(array('\\', "\0", "\n", "\r", "'", '"', "\x1a"), array('\\\\', '\\0', '\\n', '\\r', "\\'", '\\"', '\\Z'), $aParams[$sKey])
    : $aParams[$sKey]
;
}

// ----- get page content file

$sRequest=$_SERVER['REQUEST_URI'];
$sPagefile=preg_replace('/\?.*$/', '', $sRequest);
if($sPagefile=="/"){
    $sPagefile="/index";
}
$sPagefile.=".php";

/*
$sBody.='<p>
    DEBUG:<br>
    request file = '.$sRequest.'<br>
    page file = '.$sPagefile.'<br>
    params = <pre>'.print_r($aParams, 1).'</pre><br>
    </p><hr>';
*/

    // $sBody.=$oContent->getPage();

    ob_start();
    if (!@include($sPagesDir.$sPagefile)) {
        @include("./pages/error_404.php");
        echo "DEBUG: $sPagesDir.$sPagefile<br>";
    }
    $sPhpOut = ob_get_contents();
    ob_end_clean();
    $sBody.='<hr>'.$sPhpOut;



$aReplace['{{PAGE_BODY}}']=$sBody

    /*
    .$renderAdminLTE->addRow(
        '<h2>Buttons</h2>'
    )
    .$renderAdminLTE->addRow(
        $sButtontest
    )

    .$renderAdminLTE->addRow(
        $renderAdminLTE->addCol('| col w=1', 1 )
        .$renderAdminLTE->addCol('| col w=3', 3 )
        .$renderAdminLTE->addCol('| col w=1', 1 )
    )
    */
    ;


// ---------- send content
$sTemplate=file_get_contents('config/page.tpl.php');
echo $renderAdminLTE->render($sTemplate,$aReplace);
